package com.dsic.gj_erp.controller.pgd;


import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmCbxxp;
import com.dsic.gj_erp.bean.pgd.PgdTzjh;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.service.jcsj.DmCbxxpService;
import com.dsic.gj_erp.service.pgd.PgdTzjhService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@RestController
@RequestMapping("/pgdTzjh")
public class PgdTzjhController {

    @Autowired
    PgdTzjhService pgdTzjhService;

    @Autowired
    DmCbxxpService dmCbxxpService;


    @PostMapping("/getTzjhPgd")
    @ResponseBody
    public ResultBean getTzjhPgd(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {
        QueryWrapper <PgdTzjh> qw =new QueryWrapper<>();


        qw.eq(StrUtil.isNotEmpty((String)map.get("dcch")),"czbh",(String)map.get("dcch"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("pl")),"pl",(String)map.get("pl"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("fd")),"fd",(String)map.get("fd"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("zt")),"zt",(String)map.get("zt"));
        qw.orderBy(true,true,"czbh","pl","fd");
        return new ResultBean(pgdTzjhService.list(qw));

    }

    @PostMapping("/saveTzjhPgdXd")
    @ResponseBody
    @AuthFunction
    public ResultBean saveTzjhPgdXd(HttpServletRequest req, @RequestBody List<PgdTzjh>list) throws Exception, CustomException {
        pgdTzjhService.saveTzjhPgdXd(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveTzjhPgdXdBack")
    @ResponseBody
    @AuthFunction
    public ResultBean saveTzjhPgdXdBack(HttpServletRequest req, @RequestBody List<PgdTzjh>list) throws Exception, CustomException {
        pgdTzjhService.saveTzjhPgdXdBack(list,req);
        return new ResultBean();
    }



    @PostMapping("/saveTzjhPgdFk")
    @ResponseBody
    @AuthFunction
    public ResultBean saveTzjhPgdFk(HttpServletRequest req, @RequestBody List<PgdTzjh>list) throws Exception, CustomException {
        pgdTzjhService.saveTzjhPgdFk(list,req);
        return new ResultBean();
    }


    @PostMapping("/getPgdBase")
    @ResponseBody
    @AuthFunction
    public ResultBean getPgdBase(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {
        Map returnMap = new HashMap();
        List<DmCbxxp> cbbm = dmCbxxpService.list(new QueryWrapper<DmCbxxp>().orderBy(true, true, "wgbs","cbbm","len(cbbm)"));
        returnMap.put("cbbm", cbbm);

        return new ResultBean(returnMap);
    }



}

