package com.dsic.gj_erp.controller.sy;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.sy.DmPipeSystem;
import com.dsic.gj_erp.bean.sy.SyLog;
import com.dsic.gj_erp.service.sy.SyLogService;
import com.dsic.gj_erp.util.IPUtils;
import io.swagger.annotations.Authorization;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import org.apache.commons.lang3.StringUtils;
import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 系统日志表 前端控制器
 * </p>
 *
 * @author xhj
 * @since 2021-04-08
 */

@RestController
@RequestMapping(value = "/api/sy/syLog")
public class SyLogController {

    @Autowired
    SyLogService syLogService;

    @AuthFunction
    @PostMapping(value = "/add")
    public ResultBean getList(HttpServletRequest httpRequest , @RequestBody SyLog syLog) {

        syLog.setIp(IPUtils.getIpAddr(httpRequest));
        syLog.setComputerName(System.getenv().get("USERNAME"));
        syLog.setUserCode((String) httpRequest.getAttribute("yhdm"));
        syLog.setUserName((String) httpRequest.getAttribute("username"));
        SimpleDateFormat df = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");//设置日期格式
        syLog.setCreateTime(df.format(new Date()));
        syLogService.save(syLog);
        return  new  ResultBean();
    }


    @PostMapping("/getList")
    public ResultBean  getList(@RequestBody Map<String, Object> paramMap){
         IPage<SyLog> page = new Page<>((Integer)paramMap.get("pageNo"), (Integer)paramMap.get("pageSize"));
        QueryWrapper qw = new QueryWrapper<DmPipeSystem>();

        Map syLog = (Map)paramMap.get("syLog");
        qw.orderByDesc("create_time");
        if (!StringUtils.isBlank((String)syLog.get("userName"))){
            qw.like("user_name",syLog.get("userName"));

        }
        if (!StringUtils.isBlank((String)syLog.get("systemCode"))){
            qw.like("system_code",syLog.get("systemCode"));

        }
        if (!StringUtils.isBlank((String)syLog.get("content"))){
            qw.like("content",syLog.get("content"));
            //qw.apply("left(content,2)=2");
        }
        if (!StringUtils.isBlank((String)syLog.get("ks"))){
            qw.apply("left(create_time,10)>='"+syLog.get("ks")+"'");
        }
        if (!StringUtils.isBlank((String)syLog.get("js"))){
            qw.apply("left(create_time,10)<='"+syLog.get("js")+"'");
        }

      //  List list = syLogService.list(qw);
     IPage<SyLog> page1 = syLogService.page(page, qw);


        //  System.out.println(page1);
        return new ResultBean(page1);
    }

    @PostMapping(value = "/del")
    public ResultBean del(@RequestBody List<String> delArr) {
        syLogService.removeByIds(delArr);
        return  new  ResultBean();
    }


}

